package com.edufound.bytedance.activity;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Color;
import android.os.Build;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.annotation.RequiresApi;

import com.edufound.bytedance.R;
import com.edufound.bytedance.application.MyApplication;
import com.edufound.bytedance.util.ContextUtil;
import com.edufound.bytedance.util.DeviceUtil;
import com.edufound.bytedance.util.Logger;

public class DialogNetworkActivity extends Activity {

    FrameLayout btnCancel;
    FrameLayout btnConfirm;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ContextUtil.setDialogNetWorkonShow(true);
        int widht = DeviceUtil.getWidth(this);
        int height = DeviceUtil.getHeight(this);
        Logger.e("widht:" + widht);
        Logger.e("height:" + height);
        DeviceUtil.initDesignSize(this, widht, height);
        View bv = this.findViewById(android.R.id.title);
        bv.setVisibility(View.GONE);
        setFinishOnTouchOutside(false);
        setContentView(R.layout.dialog_error);
        init();
        initCloseMain();
    }

    void init() {
        ContextUtil.setDialogNetWorkonShow(true);
//        btnCancel = findViewById(R.id.dialog_cancel_button);
        btnConfirm = findViewById(R.id.dialog_confirm_button);
//        btnCancel.setOnTouchListener(buttonTouch);
        btnConfirm.setOnTouchListener(buttonTouch);
    }


    @Override
    public void onAttachedToWindow() {
        super.onAttachedToWindow();
        //获取屏幕宽高,以1920*1200字节音响为基准
//        int width = mDeviceUtil.getWidth(this);
//        int height = mDeviceUtil.getHeight(this);
//        float width_scale = width / 1920f;
//        float height_scale = height / 1200f;
//        Logger.e("width_scale:" + width_scale);
//        Logger.e("height_scale:" + height_scale);
//        View view = getWindow().getDecorView();
//        WindowManager.LayoutParams lp = (WindowManager.LayoutParams) view.getLayoutParams();
//        lp.gravity = Gravity.CENTER | Gravity.LEFT;
//        lp.x = (int) (960 * width_scale) - (mDeviceUtil.dip2px(this, 480) / 2) - 104;
////        lp.y = 100;
////        lp.width = 300;
////        lp.height = 300;
//
//        Logger.e("lp.x=" + lp.x);
//        Logger.e("lp.x=" + lp.y);
//
//        getWindowManager().updateViewLayout(view, lp);
    }

    View.OnTouchListener buttonTouch = new View.OnTouchListener() {
        @RequiresApi(api = Build.VERSION_CODES.JELLY_BEAN)
        @Override
        public boolean onTouch(View view, MotionEvent motionEvent) {
            switch (motionEvent.getAction()) {
                case MotionEvent.ACTION_DOWN:
                case MotionEvent.ACTION_MOVE:
                case MotionEvent.ACTION_HOVER_MOVE:
                    view.setBackground(null);
                    view.setBackgroundResource(R.drawable.dialog_error_button_touch_bg);
                    ((TextView) ((FrameLayout) view).getChildAt(0)).setAlpha(1f);
                    ((TextView) ((FrameLayout) view).getChildAt(0)).setTextColor(Color.WHITE);
                    break;
                case MotionEvent.ACTION_CANCEL:
//                    view.setBackground(null);
//                    view.setBackgroundResource(R.drawable.dialog_error_button_bg);
//                    ((TextView) ((FrameLayout) view).getChildAt(0)).setAlpha(0.6f);
//                    ((TextView) ((FrameLayout) view).getChildAt(0)).setTextColor(Color.BLACK);
                    break;
                case MotionEvent.ACTION_UP:
                    MyApplication.exitApp();
                    break;
            }
            return true;
        }
    };

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        return true;
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        unregisterReceiver(receiver);
        ContextUtil.setDialogNetWorkonShow(false);
    }

    void initCloseMain() {
        IntentFilter intentFilter = new IntentFilter();
        intentFilter.addAction(ContextUtil.CLOSE_DIALOG_NETWORK);
        registerReceiver(receiver, intentFilter);
    }


    private BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            finish();
        }
    };

}
