package com.edufound.bytedance.base;

import android.app.Activity;
import android.os.Bundle;
import android.view.KeyEvent;

import com.edufound.bytedance.mvp.IModel;
import com.edufound.bytedance.mvp.IView;
import com.edufound.bytedance.util.ShowSamplerInfo;
import com.umeng.analytics.MobclickAgent;

public class BaseActivity<M extends IModel, V extends IView, P extends BasePresenter> extends Activity implements BaseMVP<M, V, P> {


    protected P mPresenter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //创建Presenter
        mPresenter = createPresenter();
        if (mPresenter != null) {
            //将Model层注册到Presenter中
            mPresenter.registerModel(createModel());
            //将View层注册到Presenter中
            mPresenter.registerView(createView());
        }
    }

    @Override
    protected void onResume() {
        super.onResume();
        MobclickAgent.onResume(this);
    }


    @Override
    public void onPause() {
        super.onPause();
        MobclickAgent.onPause(this); // 不能遗漏
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mPresenter != null) {
            //Activity销毁时的调用，让具体实现BasePresenter中onViewDestroy()方法做出决定
            mPresenter.destroy();
        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        ShowSamplerInfo.dispatchKeyEvent(event, this);
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public M createModel() {
        return null;
    }

    @Override
    public V createView() {
        return null;
    }

    @Override
    public P createPresenter() {
        return null;
    }
}
