package com.edufound.bytedance.mvp.model;

import android.app.Activity;

import com.edufound.bytedance.application.MyApplication;
import com.edufound.bytedance.mvp.IModel;
import com.edufound.bytedance.util.ContextUtil;
import com.edufound.bytedance.util.DeviceUtil;
import com.edufound.bytedance.util.DeviceUuidFactory;
import com.edufound.bytedance.util.SharedPerfenceUtil;

public class MainModel implements MainModelInter {
    //    private String LOAD_URL = "http://reader-test.efunbox.cn/build/stage/index/index.html?wareId=1604565055981663";
    private String LOAD_URL_YUWEN_PREPARE = "http://zijie-web.ai160.com/stage/index/index.html";
    private String LOAD_URL_YUWEN_REVIEW = "http://zijie-web.ai160.com/stage/review/review.html";
    private String LOAD_URL_MATHEMATICS_PREPARE = "https://www.baidu.com";
    private String LOAD_URL_MATHEMATICS_REVIEW = "https://www.baidu.com";
    private DeviceUtil deviceUtil;

    public MainModel() {
        deviceUtil = new DeviceUtil();
    }

    @Override
    public String getDefaultWebUrl() {
        String url = "";
        try {
            int app_code = Integer.valueOf(MyApplication.getAppCode());
            switch (app_code) {
                case 4001:
                    url = LOAD_URL_YUWEN_PREPARE;
                    break;
                case 4002:
                    url = LOAD_URL_YUWEN_REVIEW;
                    break;
                case 4003:
                    url = LOAD_URL_MATHEMATICS_PREPARE;
                    break;
                case 4004:
                    url = LOAD_URL_MATHEMATICS_REVIEW;
                    break;
            }
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return url + "?";
    }

    @Override
    public String getLoadParams(Activity activity) {
        String preuuid = SharedPerfenceUtil.getPrefString(ContextUtil.getmApplicationContext(), "", "").toString();
        if (preuuid == "") {
            preuuid = new DeviceUuidFactory(ContextUtil.getmApplicationContext()).getUuid().toString();
        }
        ContextUtil.setUuid(preuuid);
        StringBuffer params = new StringBuffer();
        params.append("uuid=" + preuuid);
        params.append("&appCode=" + MyApplication.getAppCode());
        params.append("&width=" + deviceUtil.getWidth(activity));
        params.append("&height=" + deviceUtil.getHeight(activity));
        params.append("&model=" + deviceUtil.getSystemModel());
        params.append("&versionCode=" + deviceUtil.getVersionCode(activity));
        params.append("&versionName=" + deviceUtil.getVersionName(activity));
        return params.toString();
    }

}


interface MainModelInter extends IModel {
    String getDefaultWebUrl();

    String getLoadParams(Activity activity);

}