package com.edufound.bytedance.receiver;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.text.TextUtils;

import com.edufound.bytedance.application.MyApplication;
import com.edufound.bytedance.util.Logger;
import com.edufound.bytedance.util.OkHttpUtil;

import okhttp3.Request;

public class HomeKeyEventReceiver extends BroadcastReceiver {

    String SYSTEM_REASON = "reason";
    String SYSTEM_HOME_KEY = "homekey";
    String SYSTEM_DIALOG_REASON_RECENT_APPS = "recentapps";

    @Override
    public void onReceive(Context context, Intent intent) {
        // TODO Auto-generated method stub
        String action = intent.getAction();
        if (action.equals(Intent.ACTION_CLOSE_SYSTEM_DIALOGS)) {
            String reason = intent.getStringExtra(SYSTEM_REASON);
            if (TextUtils.equals(reason, SYSTEM_HOME_KEY)) {
                Logger.e("click home");
                OkHttpUtil.postUserTime(new OkHttpUtil.ResultCallback() {
                    @Override
                    public void onError(Request request, Exception e) {
                        Logger.e("上传使用时间：onError:" + request.toString());
                        MyApplication.exitApp();
                        android.os.Process.killProcess(android.os.Process.myPid());
                    }

                    @Override
                    public void onResponse(Object response) {
                        Logger.e("上传使用时间：" + response.toString());
                        MyApplication.exitApp();
                        android.os.Process.killProcess(android.os.Process.myPid());
                    }
                });
                android.os.Process.killProcess(android.os.Process.myPid());
            } else if (TextUtils.equals(reason, SYSTEM_DIALOG_REASON_RECENT_APPS)) {
            }
        }
    }

}
