package com.edufound.bytedance.receiver;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Handler;
import android.os.Message;
import android.telephony.TelephonyManager;

import com.edufound.bytedance.activity.DialogNetworkActivity;
import com.edufound.bytedance.util.ContextUtil;
import com.edufound.bytedance.util.Logger;


/**
 * Created by Candy on 2018/4/8.
 */

public class NetworkChangeReceiver extends BroadcastReceiver {
    final int DISCONNECT = 0x21;
    final int CONNECT = 0x22;
    String strNetworkType;
    Context mContext;
    Intent startIntent;

    public NetworkChangeReceiver() {

    }

    @Override
    public void onReceive(Context context, Intent intent) {
        GetNetworkType(context);

    }

    public void GetNetworkType(Context context) {
        mContext = context;
        ConnectivityManager connectMgr = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo networkInfo = connectMgr.getActiveNetworkInfo();
        if (networkInfo != null && networkInfo.isConnected()) {
            handler.sendEmptyMessage(CONNECT);
            if (networkInfo.getType() == ConnectivityManager.TYPE_WIFI) {
                strNetworkType = "WIFI";
            } else if (networkInfo.getType() == ConnectivityManager.TYPE_MOBILE) {
                String _strSubTypeName = networkInfo.getSubtypeName();
                Logger.e("Network getSubtypeName : " + _strSubTypeName);
                int networkType = networkInfo.getSubtype();
                switch (networkType) {
                    case TelephonyManager.NETWORK_TYPE_GPRS:
                    case TelephonyManager.NETWORK_TYPE_EDGE:
                    case TelephonyManager.NETWORK_TYPE_CDMA:
                    case TelephonyManager.NETWORK_TYPE_1xRTT:
                    case TelephonyManager.NETWORK_TYPE_IDEN: //api<8 : replace by 11
                        strNetworkType = "2G";
                        break;
                    case TelephonyManager.NETWORK_TYPE_UMTS:
                    case TelephonyManager.NETWORK_TYPE_EVDO_0:
                    case TelephonyManager.NETWORK_TYPE_EVDO_A:
                    case TelephonyManager.NETWORK_TYPE_HSDPA:
                    case TelephonyManager.NETWORK_TYPE_HSUPA:
                    case TelephonyManager.NETWORK_TYPE_HSPA:
                    case TelephonyManager.NETWORK_TYPE_EVDO_B: //api<9 : replace by 14
                    case TelephonyManager.NETWORK_TYPE_EHRPD:  //api<11 : replace by 12
                    case TelephonyManager.NETWORK_TYPE_HSPAP:  //api<13 : replace by 15
                        strNetworkType = "3G";
                        break;
                    case TelephonyManager.NETWORK_TYPE_LTE:    //api<11 : replace by 13
                        strNetworkType = "4G";
                        break;

                }
                Logger.e("Network getSubtype : " + Integer.valueOf(networkType).toString());
//                ToastUtil.showToast("当前网络环境：" + strNetworkType);
            }
        } else {
            strNetworkType = "-1";
            handler.sendEmptyMessageDelayed(DISCONNECT, 500);

        }
        Logger.e("Network Type : " + strNetworkType);
    }


    Handler handler = new Handler(new Handler.Callback() {
        @Override
        public boolean handleMessage(Message msg) {
            switch (msg.what) {
                case DISCONNECT:
                    //无网络连接
                    Logger.e("NetworkChangeReceiver--DISCONNECT");
                    if (ContextUtil.isDialogNetWorkonShow()) {
                        //如果已经展示了就不展示了
                        return true;
                    }
                    startIntent = new Intent(mContext, DialogNetworkActivity.class);
                    startIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    mContext.startActivity(startIntent);
                    break;
                case CONNECT:
                    //有网络连接
                    Logger.e("NetworkChangeReceiver--CONNECT");
                    //重新连接上之后也不给提示
                    //Intent intent_restart = new Intent(ContextUtil.CLOSE_DIALOG_NETWORK);
                    //mContext.sendBroadcast(intent_restart);
                    break;
            }
            return false;
        }
    });
}
